/**
 * Copyright © 2006-2016 Web Cohesion (info@webcohesion.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.webcohesion.enunciate.api.datatype;

import com.webcohesion.enunciate.api.resources.MediaTypeDescriptor;
import com.webcohesion.enunciate.javac.decorations.type.DecoratedTypeMirror;

import java.io.Reader;
import java.util.List;

/**
 * @author Ryan Heaton
 */
public interface Syntax extends Comparable<Syntax> {

  String getId();

  String getSlug();

  String getLabel();

  boolean isEmpty();

  List<Namespace> getNamespaces();

  boolean isAssignableToMediaType(String mediaType);

  MediaTypeDescriptor findMediaTypeDescriptor(String mediaType, DecoratedTypeMirror typeMirror);

  List<DataType> findDataTypes(String name);

  Example parseExample(Reader example) throws Exception;
}
