/**
 * Copyright © 2006-2016 Web Cohesion (info@webcohesion.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.webcohesion.enunciate.util;

import com.webcohesion.enunciate.api.resources.ResourceGroup;

import java.util.Comparator;

/**
 * @author Ryan Heaton
 */
public class ResourceGroupComparator implements Comparator<ResourceGroup> {

  private final Comparator<String> pathComparator;

  public ResourceGroupComparator(PathSortStrategy strategy) {
    if (strategy == PathSortStrategy.breadth_first) {
      pathComparator = new BreadthFirstResourcePathComparator();
    }
    else {
      pathComparator = new DepthFirstResourcePathComparator();
    }
  }

  @Override
  public int compare(ResourceGroup g1, ResourceGroup g2) {
    return pathComparator.compare(g1.getSortKey(), g2.getSortKey());
  }
}
